#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "ppport.h"

#include <iwlib.h>

MODULE = Linux::Iwtools		PACKAGE = Linux::Iwtools

#/*------------------------------------------------------*/
#/* constants */
const char *PROC_NET_WIRELESS()
CODE:
 RETVAL = PROC_NET_WIRELESS;
OUTPUT:
 RETVAL

const char *PROC_NET_DEV()
CODE:
 RETVAL = PROC_NET_DEV;
OUTPUT:
 RETVAL


#/*------------------------------------------------------*/
#/* iwconfig */

HV*
iwconfig(...)
PREINIT:
  char **argv = (char **)malloc((items+1)*sizeof(char *));
  int i, rc;
CODE:
  {
    /*-- convert arguments --*/
    argv[0] = "Iwtools::iwconfig";
    for (i=0; i < items; i++) {
      argv[i+1] = SvPV(ST(i), PL_na);
    }

    /*-- prepare output variable */
    RETVAL = newHV();

    /*-- main --*/
    rc=iwconfig_main(items+1,argv, RETVAL);
    hv_store(RETVAL, "status", 6, newSViv(rc), 0);

    free(argv);
  }
OUTPUT:
  RETVAL


#/*------------------------------------------------------*/
#/* iwlist */

HV*
iwlist(...)
PREINIT:
  char **argv = (char **)malloc((items+2)*sizeof(char *));
  int i, rc;
CODE:
  {
    /*-- convert arguments --*/
    argv[0] = "Iwtools::iwlist";
    for (i=0; i < items; i++) {
      argv[i+1] = SvPV(ST(i), PL_na);
    }

    /*-- prepare output list */
    RETVAL = newHV();

    /*-- main --*/
    rc=iwlist_main(items+1, argv, RETVAL);
    hv_store(RETVAL, "status", 6, newSViv(rc), 0);

    free(argv);
  }
OUTPUT:
  RETVAL
